#ifndef OBJECTS_H
#define OBJECTS_H

// $Header: p:\\graphics\\CVS/src/GraphicsTown/Objects.H,v 1.10 2000/11/29 18:49:30 gleicher Exp $
// GraphicsTown - CS559-2000, sample solution
//
// some objects for the world
#include "GrObject.H"
#include "DrawingState.H"

// some very basic classes of objects...
// mainly for debugging
class Cube : public GrObject {
public:
  Cube(float x, float y, float z, float s, float r=1, float g=.2, float b=.2);
  Color color;
  float size;
  virtual void draw(DrawingState*);
};

class SimpleTree1: public GrObject {
public:
  SimpleTree1(float height, float radius);
  virtual void draw(DrawingState*);
  float height, radius;
};

// a rectangular patch of lawn - wish mine grew so well
class Lawn : public GrObject {
public:
	Lawn(float x1, float z1, float x2, float z2);
  float x1,z1,x2,z2;
  virtual void draw(DrawingState*);
};

// basic element of suburbia - the lot
// has a house, a yard, some trees, a driveway, ...
class SimpleLot : public GrObject {
 public:
  SimpleLot::SimpleLot(int houseType=1, int houseColor=1);
};

class TestCubes : public GrObject {
public:
  TestCubes();
  virtual void draw(DrawingState*);
};

/***********************************************************************/
/* a non-basic one... */
// signs...
typedef enum {rectangle, diamond, octagon} SignShape;

class Sign : public GrObject {
 public:
  Sign(float sx=3,float sy=3,float h=5,char* texture = "stop",
	   SignShape ss=octagon);

  float sx,sy,h;
  virtual void draw(DrawingState*);
  char* texName;
  SignShape shape;
  void drawShape(float z);
};

/***********************************************************************/
// stuff for roads
// there are many different kinds of road pieces, all share some basic
// stuffs 
class Road : public GrObject {
 public:
  Road();
  virtual void draw(DrawingState*);
  virtual void roadDraw()=0;		/* internal - assumes everything is set */
};
class StraightRoad : public Road {
 public:
  StraightRoad(int dir=0,int length=200, int nLanes = 2, 
						int shoulders = 0);
  virtual void roadDraw();

  int length;
  int nLanes;
  int shoulders;
};

extern Road* theRoads;
/***********************************************************************/
// a subdivision plot - a straight road with houses on either side
class SimpleSubdivision : public GrObject {
 public:
  StraightRoad* road;			/* only thing outside road cares about
								 */
  SimpleSubdivision(int nHouses);

  Road* nextRoad;			// next road in list

};

/***********************************************************************/
// a subdivision plot - a straight road with houses on either side
class SubdivisionBlocks : public GrObject {
 public:
  StraightRoad* road;			/* only thing outside road cares about
								 */
  SubdivisionBlocks(int nRows, int nCols, int nHousesPerBlock=6);

  int nRows;
  int nCols;
};
//**********************************************************************
class StreetLight : public GrObject {
 public:
	 double radius;
	 double poleZ;
  StreetLight(double poleZ);
	virtual void draw(DrawingState*);
	virtual void drawAfter(DrawingState*);
};

#endif


