#ifndef TEXTURE_H
#define TEXTURE_H
// $Header: p:\\graphics\\CVS/src/GraphicsTown/Texture.H,v 1.2 2000/11/24 22:09:35 gleicher Exp $
//
// simple texture manager
// (c) 2000 Michael L. Gleicher
// This code may be modified and re-used providing that proper credit
// is given to the author. 

// Originally written for:
// GraphicsTown - CS559-2000, project 3, sample solution
//
// Management of textures
// probably more complicated than it needs to be, but it makes some
// other things simple
//
// the trick is to only have to load each texture once, no matter how
// many things use it

class Texture {
public:
  // what we give to LibTarga
  char* name;
  char* fname;					// the file name
  // what libtarga gives back...
  void* bits;
  int width;
  int height;

  GLuint texName;				// GL texture name

  // keep everything on a linked list
  Texture* next;
};

extern Texture* theTextures;

// get a texture- will hunt it down and load it if its not already loaded
// this even does the bind texture for you
// Note: the name should not include the ".tga"
// Note: the search path is (presently) hard coded into the .cpp
// file. this should be fixed someday.
GLuint fetchTexture(char* name, bool wrapS=false, bool wrapT=false);
#endif
