// $Header: p:\\graphics\\CVS/src/GraphicsTown/Texture.cpp,v 1.12 2000/11/28 01:15:48 gleicher Exp $
//
// simple texture manager
// (c) 2000 Michael L. Gleicher
// This code may be modified and re-used providing that proper credit
// is given to the author. 
//
// GraphicsTown - CS559-2000, sample solution
//

#include "GrTown_PCH.H"
#include "Texture.H"
#include "libtarga.h"

// the list of all textures loaded in already
Texture* theTextures=0;

// the places to look for textures...
// this should be modified to look where you might find your textures.
// ultimately, there should be a better way than just sticking this in
// the code.
char* texturePaths[] = {
	".", "./Textures",
  "Textures/signs",
  "../Textures/signs",
  "Textures/Textures",
  "../Textures/Textures",
  "Textures/Objects",
  "../Textures/Objects",
  "c:/src/GraphicsTown/Textures/signs",
  "c:/src/GraphicsTown/Textures/Textures",
  0 };

// utility routine
static char* newString(char* s)
{
  char* n = new char [strlen(s)+1];
  strcpy(n,s);
  return n;
}

// the core guts of the thing...
GLuint fetchTexture(char* name, bool wrapS, bool wrapT)
{
  char buf[200];

  int w, h;
  void* b=0;

  int i;

  // check to see if we've loaded the texture alredy
  for(Texture* t=theTextures; t; t=t->next) {
	if (!strcmp(t->name,name)) {
	  glBindTexture(GL_TEXTURE_2D,t->texName);
	  return t->texName;
	}	  
  }

  // we need to load the file
  // search everywhere on the path until we find it
  for(i=0; texturePaths[i] && !b; i++) {
	_snprintf(buf,200,"%s/%s.tga",texturePaths[i],name);
	printf("Trying: `%s'\n",buf);
	b = tga_load(buf,&w,&h,TGA_TRUECOLOR_32);
  }
  // if we found an image, load it in
  if (b) {
	Texture* t = new Texture;
	t->name = newString(name);
	t->fname = newString(buf);
	t->bits = b;
	t->width = w;
	t->height = h;
	t->next = theTextures;
	theTextures = t;
	
	glGenTextures(1,&t->texName);
	
	printf("Created texture %u for %s\n",t->texName,t->name);
	glBindTexture(GL_TEXTURE_2D,t->texName);
	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, 
					wrapS ? GL_REPEAT : GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, 
					wrapT ? GL_REPEAT : GL_CLAMP);
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);

	int e = gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA,w,h,GL_RGBA,GL_UNSIGNED_BYTE,b);

	glBindTexture( GL_TEXTURE_2D, t->texName );

	printf("Build MipMap(%d %d) returns %d = %s\n",w,h,e,gluErrorString(e));
	return t->texName;
  } else {
	printf("!! Couldn't load texture `%s'~\n",name);
	return 0;
  }
}
